#ifndef BEACONH
#define BEACONH
#include <netinet/in.h>

#define BEACON_PORT	1200
#define MAX_WIRELESS_IFS 10

typedef enum {BEACON, BEACON_REQ, BEACON_REPLY} BMSGTypes;

typedef struct BSBeacon {
	struct in_addr wlAddr;   /* Of Base Station */
	struct in_addr wiAddr;   /* Of Base Station */
	struct in_addr bAddr;    /* Beacon address on wireless net */
} BSBeacon;

typedef struct BeaconReq {
	struct in_addr addr;
} BeaconReq;

typedef struct BeaconMsg {
	BMSGTypes type;
	struct timeval curTime;
	union {
		BSBeacon beacon;
		BeaconReq req;
	} data;
} BeaconMsg;

#define ETHER_ADDR_SIZE 6

#define DEL_BEACON		0x1
#define ADD_BEACON		0x2
#define DEL_ALL_BEACONS		0x3
struct ifbeacon {
#define	IFNAMSIZ	16
	char	ifb_name[IFNAMSIZ];		/* if name, e.g. "en0" */
	char	cmd;
	beacon_cntr beacon;
};

extern void DelBeacon(int ifs, char *addr, char *iface);
extern void AddBeacon(int ifs, char *addr, char *iface);
extern int SendBeaconReq(char *addr, int port);
extern int InitBeacon(char *iface);

#endif
