/*
 * cstream.h --
 *
 *	This module implements lisp-like streams in C.
 *
 * Copyright 1990 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 * $Header: /usr/local/daedalus/include/RCS/cstream.h,v 1.1 1996/11/06 22:00:31 hari Exp $ SPRITE (Berkeley)
 */

#ifndef CSTREAM_H
#define CSTREAM_H

#include "coproc.h"

#define MAX_ELEM_NUM 4000

typedef struct {
    int         buf[MAX_ELEM_NUM];
    int	       *curElem;
    int	       *maxElem;
    COPROCtype  consumerProc;
    COPROCtype  producerProc;
} Cstream;

#define OpenCstream(cstr, expr) (		\
    *(cstr) = AllocCstream(),			\
    ( CreateCoproc(&(*(cstr))->producerProc)  	\
	?   *(cstr)				\
	:(  (expr),				\
	    SwitchCoproc(&(*(cstr))->producerProc, &(*(cstr))->consumerProc ), \
	    SwitchCoproc(&(*(cstr))->producerProc, &(*(cstr))->consumerProc ), \
	    printf("Error: OpenCstream\n"),	\
	    *(cstr)				\
	)					\
    )						\
)

/*
#define CloseCstream(cstr) free(cstr)

#define PutCstream(cstr, elem) (		\
    *(cstr)->maxElem++ = (int) (elem),		\
    ((cstr)->maxElem == (cstr)->buf+MAX_ELEM_NUM\
	?   *((cstr)->maxElem-1)		\
	:(  SwitchCoproc(&(cstr)->producerProc, &(cstr)->consumerProc ), \
	    *((cstr)->maxElem-1)		\
	)					\
    )						\
)

#define GetCstream(cstr, elem) (		\
    ((cstr)->curElem < (cstr)->maxElem		\
	?(  *(elem) = *(cstr)->curElem++,	\
	    1					\
	):( ((cstr)->isEmpty == 1		\
		?   0				\
		:(  (cstr)->curElem = (cstr)->buf,	\
		    (cstr)->maxElem = (cstr)->buf,	\
		    SwitchCoproc(&(cstr)->consumerProc, &(cstr)->producerProc),\
		    ((cstr)->isEmpty == 1	\
			?   0			\
		        :(  *(elem) = *(cstr)->curElem++,	\
		    	    1			\
			)			\
		    )				\
	        )				\
	    )					\
	)					\
    )						\
)
*/

extern Cstream *AllocCstream();
extern int PutCstream();
extern int GetCstream();

#endif CSTREAM_H
