#ifndef BEACONH
#define BEACONH
#include <kvm.h>
#include <netinet/in.h>

#define LOAD_PORT	1400
#define MAX_MOBILES     10         /* the maximum number of mobiles on the 
				      wireless net */
typedef enum {LOAD} LMSGTypes;

typedef struct LoadInfo {
     struct in_addr mhAddr; /* IP address of a mobile */
     unsigned short pctLoad;/* the percentage of traffic to/from this mobile 
			       during the last measurement period. */
}

typedef struct BSLoad {
	struct in_addr wlAddr;
	struct in_addr wiAddr;
	unsigned long  totalLoad;  /* the total number of bytes sent over the 
				      wireless net during the most measurement
				      period. */
	LoadInfo ldinfo[MAX_MOBILES]; 
} BSLoad;

typedef struct LoadMsg {
	BMSGTypes type;
	struct timeval curTime;
	union {
	     BSLoad beacon;
	     BeaconReq req;
	} data;
} BeaconMsg;

#endif
