#ifndef OSFLAGS
/* minimum parameter to usleep */
#define MIN_USLEEP 1500

/* define either RANDOM or RAND to use random() instead of rand() */
#define RANDOM

/* define one of USLEEP or NANOSLEEP if your system has it, program uses 
   sleep by default */
#define USLEEP

/* define MULTICAST if support is available */
#define MULTICAST

/* define TOS if TOS sockopts are available */
#define TOS

/* define THREADED if you want to use the MT safe calls */

/* useful defaults for various systems */

#ifdef OSF1
#endif

#ifdef AIX4
#endif

#ifdef SunOS
#undef TOS
#undef MULTICAST
#endif

#ifdef Solaris
#undef TOS
#undef RANDOM
#undef USLEEP
#define RAND
#define NANOSLEEP
#define THREADED
#endif

#ifdef HPUX
#undef TOS
#undef RANDOM
#define RAND
#undef USLEEP
#endif

#ifdef ULTRIX
#undef TOS
#undef MULTICAST
#endif

#ifdef BSDI
#include <sys/unistd.h>
#include <sys/uio.h>
#define TCPSTATS
#define TCP_ENABLE_STATS  0x800
#define TCP_MONITOR
#define TCP_GET_SRTT            0x800000 /* get srtt from kernel */
#define TCP_GET_RTTVAR          0x1000000/* get rtt variance from kernel */
#define TCP_IGNORE_PEER         0x4000000 /* Ignore peer's mss (asymmetry) */
#define TCP_NOTSTAMP            0x8000000 /* Eliminate timestamps */

#include "/sys/netinet/tcp_stats.h"
#endif

#if defined(__cplusplus)
extern "C" {
    void microsleep(int usec);
}
#else
extern void microsleep(int usec);
#endif

#endif
