#ifndef SHMEMLIB
#define SHMEMLIB

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#define SHM_ANY_KEY		IPC_PRIVATE

typedef int SHM_Status;

typedef struct SHM_ID {
  int id;
  void *address;
} SHM_ID;

extern SHM_ID*		SHM_Open(int key);
extern SHM_ID*		SHM_New(int key, u_int size);
extern void		SHM_Close(SHM_ID *idPtr);
extern SHM_Status 	SHM_Free(SHM_ID *idPtr) ;
extern void* 		SHM_Attach(SHM_ID *idPtr, void *addr);
extern SHM_Status	SHM_Detach(SHM_ID *idPtr);
extern void 		SHM_SetMode(SHM_ID *idPtr, short mode);

#endif
