/*
 * Converted from the C++ library.
 */

#ifndef _STAT_H
#define _STAT_H

#include <math.h>

typedef struct{
    int		n;
    double	sumX;
    double	sumX2;
    double	min;
    double	max;
} Stat;

#define MAX_LAG		10

typedef struct{		/* Subclass of Stat */
    Stat	stat;
    double	sumXY[MAX_LAG];
    double	firstX[MAX_LAG];
    double	lastX[MAX_LAG];
} AutoStat;

typedef struct{		/* Subclass of AutoStat */
    AutoStat	batchStat;	/* for batch means */
    AutoStat	stat;		/* for individual means */
    int		batchSize;
    int		batchN;
    double	batchSumX;
} BatchStat;

void InitStat();
void AddStat();
int NStat();
double AveStat();
double VarStat();
double SDStat();
double SEStat();
double ConfStat();
void AddStatStat();

void InitAutoStat();
void AddAutoStat();
void LagAutoStat();
void PrintAutoStat();
double SEAutoStat();
double ConfAutoStat();

void InitBatchStat();
void AddBatchStat();
void PrintBatchStat();

#endif _STAT_H
