#ifndef WROUTEDH
#define WROUTEDH
#include <kvm.h>
#include <netinet/in.h>
#include "wavelan.h"
#include "easysocklib.h"
#include "sample.h"
#include "encap.h"

#define MAX_BS 		8
#define MAX_SAMPLES 	4
#define TIMER_RATE	5
#define BEACON_TIMEOUT  30

typedef enum {BS_INACTIVE=0, BS_BUFFERING, BS_FORWARDING} BS_States;

typedef struct BSState {
     char wiName[20];
     char wlName[20];
     BS_States state;
     Socket *sdPtr;
     u_char ethAddr[WAVELAN_ADDR_SIZE];
     struct in_addr wlAddr;
     struct in_addr wiAddr;
     int lastSamp;
     WLSamp samples[MAX_SAMPLES];
} BSState;

typedef struct RouteState {
     int ifs;			/* interface socket */
     int routes;		/* route socket */
     struct in_addr locAddr;
     struct in_addr realAddr;
     struct in_addr multiAddr;
     BSState *curBSPtr;
     int numBufing;
     int desBufing;
     int numBS;
     int powThresh;
     int state;
     struct BSState *BSPtr [MAX_BS];
} RouteState;

extern void ClearOld(RouteState *sysStatePtr, struct timeval *curTimePtr);
extern BSState * AnalyzeState(RouteState *sysStatePtr);
extern int SendUnencapReq(BSRTypes type, BSState *bsPtr, struct in_addr la,
			  struct in_addr ra, struct in_addr ma, 
			  struct mobileip_ids *ids);

#endif
