#ifndef WROUTEDH
#define WROUTEDH
#include <kvm.h>
#include <netinet/in.h>
#include "wavelan.h"
#include "easysocklib.h"

#define MAX_BS 		8
#define MAX_SAMPLES 	4
#define TIMER_RATE	5

typedef enum {INACTIVE, BUFFERING, FORWARDING} BSState;

typedef struct BSstate {
	char *name;
	int state;
	Socket *sdPtr;
	u_char ethAddr[WAVELAN_ADDR_SIZE];
	struct in_addr wlAddr;
	struct in_addr wiAddr;
	int lastSamp;
	WLSamp samples[MAX_SAMPLES];
} BSstate;

typedef struct RouteState {
	struct in_addr locAddr;
	struct in_addr realAddr;
	struct in_addr multiAddr;
	int curBS;
	int numBuffering;
	int numBS;
	int powThresh;
	int state;
	BSstate BS[MAX_BS];
} RouteState;

extern void ClearOld(RouteState *sysStatePtr, struct timeval *curTimePtr, int ifs) ;

extern int AnalyzeStats(RouteState *sysStatePtr);
#endif
