#include <stdio.h>
#include <varargs.h>

int 
dprintf(level, format, va_alist)
int level;
const char *format;
va_dcl
{
  static currentDebugLevel = 0;
  int n = 0;
  va_list ap;
#ifdef DBG_TIME
  time_t the_time;
#endif
  
  if (level <= 0) {
    currentDebugLevel = -level;
  } else {
       if (currentDebugLevel >= level) {
	    va_start(ap);
#ifdef DBG_TIME
		the_time=time(NULL);
#endif
	    fprintf(stderr, "DEBUG %d: ", level);
	    n = vfprintf(stderr, format, ap);
	    va_end(ap);
       }
  }

  fflush(stderr);
  fflush(stdout);
  return n;
}

int 
SetDebugLevel(int level)
{
  dprintf(-level, "debug level set to %d\n", level);
}

void
dperror(int level, char *format)
{
     static currentDperrorLevel=0;
     int n=0;
     
     if (level <= 0) 
	  currentDperrorLevel = -level;
     else {
	  if (currentDperrorLevel >= level) {
	       fprintf(stderr, "DPERROR %d: ", level);
	       perror(format);
	  }
     }
}

int 
SetDperrorLevel(int level)
{
     fprintf(stderr, "perror level set to %d\n", level);
     dperror(-level, "");
}

