/* Configuration file Parsing */
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include "conf.h"

/* Parses configuration file to find values */
/* Variable args are triples (name, type, value): */
/* <name> is name in configuration file */
/* <type> is type of value, expressed as what scanf would do to a string */
/* <value> is a pointer to the value associated with the name (filled in by this function) */

int ParseConfFile(char *confFileName, int numConfPairs, ...)
{
	va_list namesValues;
	int i;
	FILE *confFile;
	char name[100], value[100], *queryName;
	char errStr[100];
	char *valType;
	void *valPtr;
	
	/* Open the conf file */
	if ((confFile=fopen(confFileName, "r"))==NULL){
		sprintf(errStr, "Couldn't open configuration file %s:", confFileName);
		perror(errStr);
		return(-1);
	}

	/* Start the variable argument list at the argument after the numConfPairs argument */
	va_start(namesValues, numConfPairs);

	for(i=0; i<numConfPairs; i++){
		/* Get the next variable arg (the thing to look for in the conf file) */
		queryName=va_arg(namesValues, char *);
		valType=va_arg(namesValues, char *);
		valPtr=va_arg(namesValues, void *);
		
		rewind(confFile);
		do {
			fscanf(confFile, "%s %[^\n]\n", name, value);
			if (strcmp(queryName, name)==0){
				sscanf(value, valType, valPtr);
				goto found;
			}
		} while(!feof(confFile));
		fprintf(stderr, "Couldn't find entry for name %s in file\n", queryName);
		valPtr=NULL;
	  found:
	}

	va_end(namesValues);
	return(0);
}
