#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <kvm.h>
#include <kread.h>

/*
 * Read kernel memory, return 0 on success.
 */
int
kread(addr, buf, size, kvmd)
	u_long addr;
	char *buf;
	int size;
	kvm_t *kvmd;
{

	if (kvm_read(kvmd, addr, buf, size) != size) {
		/* XXX this duplicates kvm_read's error printout */
		(void)fprintf(stderr, "kvm_read %s\n", 
		    kvm_geterr(kvmd));
		return (-1);
	}
	return (0);
}

