#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <math.h>
#include <kvm.h>
#include <sys/file.h>
#include <nlist.h>

#include <net/if.h>
#include <net/if_dl.h>
#include <net/if_types.h>
#include "in.h"
#include <netinet/if_ether.h>
#include <net/route.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netinet/in_var.h>

#include "ip_mobile.h"
#include "option.h"

int ae = 0;
int de = 0;
int au = 0;
int du = 0;
int ru = 0;
int eu = 0;
int cs = 0;
int sm = 0;
int cm = 0;
int sh = 0;
int st = 0;
int ch = 0;
int ia = 0;
int r  = 0;
int l  = 0;
int ifon = 0;
int ifoff = 0;
int bthresh = 0;
int bpid = 0;
char *maddr = "224.6.10.69";
char *saddr = "204.161.78.34";
char *ifaddr = "204.161.78.36";
int ttl = 4;


Option optionArray[] = {
{OPT_TRUE, "ae", (char *)&ae,
	 "add encap"},
{OPT_TRUE, "de", (char *)&de,
	 "del encap"},
{OPT_TRUE, "au", (char *)&au,
	 "add unencap"},
{OPT_TRUE, "du", (char *)&du,
	 "disable unencap"},
{OPT_TRUE, "ru", (char *)&ru,
	 "remove unencap"},
{OPT_TRUE, "eu", (char *)&eu,
	 "enable unencap"},
{OPT_TRUE, "cs", (char *)&cs,
	 "change source address"},
{OPT_TRUE, "ia", (char *)&ia,
	 "inet addr any"},
{OPT_TRUE, "r", (char *)&r,
	 "reset"},
{OPT_TRUE, "l", (char *)&l,
	 "list unencap state in kernel"},
{OPT_STRING, "m", (char *)&maddr,
	 "multi addr"},
{OPT_STRING, "s", (char *)&saddr,
	 "unicast addr"},
{OPT_STRING, "i", (char *)&ifaddr,
	 "output interface addr (string when used w/ ifon, ifoff)"},
{OPT_INT, "t", (char *)&ttl,
	 "ttl"}
};

struct nlist nl[] = {
#define	N_MIPSTATE	0
	{ "_mip_state" },
	{""},
};

char *memf = NULL;
char *nlistf = NULL;
kvm_t *kvmd;

char *InetNtoa(struct in_addr addr)
{
        char *s = inet_ntoa(addr);
        char *p = (char *)malloc(1000);
        strcpy(p, s);
	p[strlen(s)+1]='\0';
        return p;
}

/*
 * Read kernel memory, return 0 on success.
 */
int
kread(addr, buf, size)
	u_long addr;
	char *buf;
	int size;
{

	if (kvm_read(kvmd, addr, buf, size) != size) {
		/* XXX this duplicates kvm_read's error printout */
		(void)fprintf(stderr, "kvm_read %s\n", 
		    kvm_geterr(kvmd));
		return (-1);
	}
	return (0);
}

void GetState(int state, char *string)
{
	 switch (state) {
	 case 0:
		  strcpy(string, "MIP_UNUSED");
		  break;
	 case 1:
		  strcpy(string, "MIP_UNENCAP_FWD");
		  break;
	 case 2:
		  strcpy(string, "MIP_UNENCAP_BUF");
		  break;
	 case 3:
		  strcpy(string, "MIP_ENCAP");
		  break;
	 case 4:
		 strcpy(string, "MIP_CSHRC");
                 break;
	 }
}

void PrintBSState(u_long stateaddr)
{
	int i;
	struct mobileip_state mst;
	char name[40];
	char stateStr[30];
	struct in_multi addr;
	struct ifnet ifp;
	
	kread(stateaddr, (char *)&mst, sizeof(struct mobileip_state));
	
	printf("%d mobiles\n", mst.num_mobile);
	for (i = 0; i < mst.num_mobile; i++){

		 kread(mst.trans[i].ifp, (char *) &ifp, sizeof(ifp));
		 kread(ifp.if_name, (char *) &name, 10);
		 
		 kread(mst.trans[i].multi_addr, (char *) &addr, sizeof(struct in_multi));

		 GetState(mst.trans[i].state, stateStr);
		 
		 printf("%d :", i);
		 printf("state=%s ", stateStr);
		 printf("hdrOnly=%d ", mst.trans[i].hdrOnly);
		 printf("if=%s ", name);
		 printf("multi_addr=%s ", InetNtoa(addr.inm_addr));
		 printf("\tmttl=%d ", mst.trans[i].multicast_ttl);
		 printf("\tins_addr=%s\n", InetNtoa(mst.trans[i].ins_addr));

	}
}

void PrintMHState(u_long stateaddr)
{
	struct mobilemh_state mst;
	
	kread(stateaddr, (char *)&mst, sizeof(struct mobilemh_state));

	printf("Blocked Interface=%s\n", (char *) mst.mipBlockedIfs);
	printf("Handoff Controller PID=%d\n", mst.mipHandoffCtlrPid);
	printf("Burst Threshold=%d\n", mst.mipBurstThreshold);
	printf("Num Consec Packets=%d\n", mst.mipBurstCount);
	printf("Burst is from %s\n", mst.mipBurstIf);
	printf("Inserted address is %s\n", inet_ntoa(mst.mip_mh_addr));
	printf("HA address is %s\n", inet_ntoa(mst.tunnel_addr));
}

void main(int argc, char *argv[])
{
     int fd, j; 
     struct ip_mobreq req;
     char buf[255];
     int option=0;

     Opt_Parse (argc, argv, optionArray, Opt_Number(optionArray), 0);

     /* setup basestation stats retrieval */
     if ((kvmd = kvm_openfiles(nlistf, memf, NULL, O_RDONLY, buf)) == NULL) {
	     fprintf(stderr, "kvm_open: %s\n", buf);
	     exit(1);
     }
     if (kvm_nlist(kvmd, nl) < 0 || nl[0].n_type == 0) {
	     if (nlistf)
		     fprintf(stderr, "%s: no namelist\n", nlistf);
	     else
		     fprintf(stderr, "no namelist\n");
	     exit(1);
     }
     
     if (l) {
	     PrintBSState(nl[N_MIPSTATE].n_value);
     }
     
     if (ia)
	     req.imr_ifaddr.s_addr = INADDR_ANY;
     else 
	     req.imr_ifaddr.s_addr = inet_addr(ifaddr);
     req.imr_ins_addr.s_addr = inet_addr(saddr);
     req.imr_multi_addr.inm_addr.s_addr = inet_addr(maddr);
     req.imr_multicast_ttl = ttl;
     
     fd = socket(AF_INET, SOCK_STREAM, 0);
     
     j = sizeof(req);
     if (ae) 
	     option = IP_ADD_ENCAP;
     if (de) 
	     option = IP_DEL_ENCAP;
     if (au) 
	     option = IP_ADD_UNENCAP;
     if (du) 
	     option = IP_DIS_UNENCAP;
     if (ru) 
	     option = IP_DEL_UNENCAP;
     if (eu) 
	     option = IP_ENA_UNENCAP;
     if (r) 
	     option = IP_CLR_ALL;
     
     if (option)
	     if (setsockopt(fd,IPPROTO_IP, option,(char *)&req,j) < 0){
		     fprintf(stderr, "While trying option %d...", option);
		     perror("setsockopt");
	     }
}





