/***********************************************************************
 *
 * strtosize.c
 *
 *	strtobytes converts a string to a number of bytes.  It understands
 *	things like "K", "M", and so on as multiples of 1024.  The number
 *	returned is a 64 bit integer, but it may be truncated back to 32
 *	bits.
 *
 * Copyright 1993 Regents of the University of California
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 ***********************************************************************
 */

#ifndef lint
static char rcsid[] = "$Header: Locker:$";
#endif /* not lint */

#include <ctype.h>

#ifndef	NULL
#define	NULL	((void*)0)
#endif

double
strtosize (s, endPtr)
char*	s;
char**	endPtr;
{
    double	result = 0.0;
    char*	curPos;
    int		endLoop = 0;
    double	curVal;

    if (s == NULL) {
	return (result);
    }

    while (!endLoop) {
	curVal = (double)strtol (s, &curPos, 0);
	if (curPos == s) {
	    endLoop = 1;
	} else {
	    s = curPos;
	    switch (toupper(*s)) {
	      case 'T':
		curVal *= 1024.0;
	      case 'G':
		curVal *= 1024.0;
	      case 'M':
		curVal *= 1024.0;
	      case 'K':
		curVal *= 1024.0;
		break;
	      default:
		break;
	    }
	    result += curVal;
	    if ((*s == '\0') || isspace(*s)) {
		endLoop = 1;
	    }
	}
    }
    if (endPtr != NULL) {
	*endPtr = s;
    }
    return (result);
}
