#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <fcntl.h>
#include <errno.h>
#include <assert.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <math.h>
#include <sys/time.h>

#include "osflags.h"

void
microsleep(int usec) 
{
     struct timeval time1, time2;
#ifdef NANOSLEEP
     struct timespec sleepTime, left;
#endif
     static minUsleep = MIN_USLEEP;
     int temp;

     if (usec > minUsleep) {
	  gettimeofday(&time1, NULL);
#ifdef USLEEP
	  usleep(usec);
#else
#ifdef NANOSLEEP
	  sleepTime.tv_sec = usec/1000000;
	  sleepTime.tv_nsec = (usec % 1000000) * 1000;
	  nanosleep(&sleepTime, &left);
#else
	  sleep(usec/1000000);
#endif
#endif
	  gettimeofday(&time2, NULL);
	  temp = (time2.tv_usec - time1.tv_usec) +
	       (time2.tv_sec - time1.tv_sec) * 1000000;
	  if (temp > 1.25 * usec) {
	       dprintf(109, "usec %d realWait %d minUsleep %d\n", 
		       usec, temp, minUsleep);
	       minUsleep = temp;
	  }
     }
}
